// DVDSubEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DVDSubEdit.h"
#include "DVDSubEditDlg.h"
#include "Cell.h"
#include "Utils.h"
#include "SubPic.h"
#include "MiscDialogs.h"
#include <wingdi.h>

#ifndef AC_SRC_ALPHA
#define AC_SRC_ALPHA                0x01
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_V_MOVE 600
#define MAX_BORDER 100
#define GREY RGB(100,100,100)
#define BLACK RGB(0,0,0)
#define RED RGB(255,0,0)
#define GREEN RGB(0,134,37)
#define BLUE RGB(0,0,255)


#define DispThis1(ID,format) {SetDlgItemText(ID,format);}
#define DispThis2(ID,format,val) {char Temp[512]; sprintf(Temp,format,val);SetDlgItemText(ID,Temp);}
#define DispThis3(ID,format,val1,val2) {char Temp[512]; sprintf(Temp,format,val1,val2);SetDlgItemText(ID,Temp);}
			  
void OutputError(char* AMessage, int Langage)
{
	AfxMessageBox(AMessage,MB_ICONSTOP);
#if _DEBUG
	OutputDebugString(Message);
	OutputDebugString("\n");
#endif
}

enum
{
	BORDER_CUSTOM = 0,
	BORDER_SAFE,
	BORDER_4_3_L,
	BORDER_4_3_LS,
};

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	CDVDSubEditDlg	*m_Edit;

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnShowhelp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	SetDlgItemText(IDC_VERSIONSTRING,m_Edit->m_Version);
	return TRUE; 
}

void CAboutDlg::OnShowhelp() 
{
	OpenRSCFile(IDR_HELPFILE, ".pdf");
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_SHOWHELP, OnShowhelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
class CScanDlg : public CDialog
{
public:
	CScanDlg();

	CSubPicEngine*	m_Engine;
	void			DisplayInfo(int Progress, char* Info, char* Message);

// Dialog Data
	//{{AFX_DATA(CScanDlg)
	enum { IDD = IDD_SCANDIALOG };
	CProgressCtrl	m_Progress;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScanDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CScanDlg)
	afx_msg void StartScan();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CScanDlg::CScanDlg() : CDialog(CScanDlg::IDD)
{
	//{{AFX_DATA_INIT(CScanDlg)
	//}}AFX_DATA_INIT
	m_Engine = 0;
}

void CScanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScanDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScanDlg, CDialog)
	//{{AFX_MSG_MAP(CScanDlg)
	ON_BN_CLICKED(IDC_RUN, StartScan)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CScanDlg::StartScan() 
{
	m_Engine->m_AbortNow = true;
}

void CScanDlg::DisplayInfo(int Progress, char* Info, char* AMessage)
{
	m_Progress.SetPos(Progress);
	SetDlgItemText(IDC_INFO,Info);
	SetDlgItemText(IDC_MESSAGE,AMessage);
}

BOOL CScanDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
	{
		switch(pMsg->wParam)
		{
			// Must be all CAPS...
		case VK_ESCAPE: m_Engine->m_AbortNow = true;  break;
		default: return GetParent()->PreTranslateMessage(pMsg);  break;
		}
		return TRUE;
	}
	else return CDialog::PreTranslateMessage(pMsg);
}

/////////////////////////////////////////////////////////////////////////////
// CDVDSubEditDlg dialog

CDVDSubEditDlg::CDVDSubEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDVDSubEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDVDSubEditDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	pErrorFunction = OutputError;
}

void CDVDSubEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDVDSubEditDlg)
	DDX_Control(pDX, IDC_SHOWMOD, m_ShowModified);
	DDX_Control(pDX, IDC_BORDERSELECT, m_BorderSelect);
	DDX_Control(pDX, IDC_BORDERS, m_BorderSlider);
	DDX_Control(pDX, IDC_START, m_StartCommand);
	DDX_Control(pDX, IDC_PIXSELECT, m_PixelSelect);
	DDX_Control(pDX, IDC_TRANSPARENCYS, m_TransSlider);
	DDX_Control(pDX, IDC_SHOWVIDEO, m_ShowVideo);
	DDX_Control(pDX, IDC_SAVEALL, m_SaveAll);
	DDX_Control(pDX, IDC_NOCLUT, m_IgnoreCLUT);
	DDX_Control(pDX, IDC_REVERTSAVED, m_Revert);
	DDX_Control(pDX, IDC_MOVEUDS, m_MoveVSlider);
	DDX_Control(pDX, IDC_VCIDSELECT, m_VCIDSelect);
	DDX_Control(pDX, IDC_SPUSLIDER, m_SPUSlider);
	DDX_Control(pDX, IDC_STREAMSELECT, m_StreamSelect);
	DDX_Control(pDX, IDC_COMMANDS, m_CommandDisplay);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDVDSubEditDlg, CDialog)
	//{{AFX_MSG_MAP(CDVDSubEditDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_SPUR, OnSpur)
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_STREAMSELECT, OnSelchangeStreamselect)
	ON_BN_CLICKED(IDC_SPUL, OnSpul)
	ON_BN_CLICKED(IDC_REVERTSAVED, OnRevertsaved)
	ON_BN_CLICKED(IDC_PVCID, OnPvcid)
	ON_BN_CLICKED(IDC_NVCID, OnNvcid)
	ON_BN_CLICKED(IDC_PSTREAM, OnPstream)
	ON_BN_CLICKED(IDC_NSTREAM, OnNstream)
	ON_BN_CLICKED(IDC_APPLYTOALL, OnApplytoall)
	ON_BN_CLICKED(IDC_REVERTALL, OnRevertall)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_NOCLUT, OnNoclut)
	ON_BN_CLICKED(IDC_SAVEALL, OnSaveall)
	ON_BN_CLICKED(IDC_DEFBUTTON, OnDefbutton)
	ON_EN_KILLFOCUS(IDC_MOVEUDE, OnKillfocusMoveude)
	ON_BN_CLICKED(IDC_SHOWVIDEO, OnShowvideo)
	ON_CBN_SELCHANGE(IDC_PIXSELECT, OnSelchangePixselect)
	ON_CBN_SELCHANGE(IDC_START, OnSelchangeStart)
	ON_CBN_SELCHANGE(IDC_BORDERSELECT, OnSelchangeBorderselect)
	ON_BN_CLICKED(IDC_SHOWMOD, OnShowmod)
	ON_EN_KILLFOCUS(IDC_BORDERE, OnKillfocusBordere)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_HELP_MANUAL, OnHelpManual)
	ON_COMMAND(ID_HELP_ONTHEWEB, OnHelpOntheweb)
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_EDIT_APPLYALL, OnEditApplyall)
	ON_NOTIFY(UDN_DELTAPOS, IDC_MOVEB, OnDeltaposMoveb)
	ON_NOTIFY(UDN_DELTAPOS, IDC_BORDERB, OnDeltaposBorderb)
	ON_CBN_SELCHANGE(IDC_VCIDSELECT, OnSelchangeStreamselect)
	ON_COMMAND(ID_FILE_OPENVOB, OnFileOpenvob)
	ON_COMMAND(ID_FILE_OPENDOMAIN, OnFileOpendomain)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_EDIT_REVERTTHIS, OnRevertsaved)
	ON_COMMAND(ID_EDIT_REVERTALL, OnRevertall)
	ON_COMMAND(ID_FILE_SAVE, OnSaveall)
	ON_WM_DROPFILES()
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
END_MESSAGE_MAP()

BOOL CDVDSubEditDlg::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	// Multiline tooltips: http://www.thecodeproject.com/miscctrl/tooltipex.asp
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);
		switch(nID)
		{
		case IDC_STREAMSELECT : pTTT->lpszText = "Filter subpics based on stream ID"; break; 
		case IDC_SPUL : pTTT->lpszText = "Go to previous subpic"; break; 
		case IDC_SPUR : pTTT->lpszText = "Go to next subpic"; break; 
		case IDC_REVERTSAVED : pTTT->lpszText = "Reloads this subpic from disk"; break; 
		case IDC_VCIDSELECT : pTTT->lpszText = "Filter subpics based on V/CID"; break; 
		case IDC_PVCID : pTTT->lpszText = "Go to previous V/CID"; break; 
		case IDC_NVCID : pTTT->lpszText = "Go to next V/CID"; break; 
		case IDC_PSTREAM : pTTT->lpszText = "Go to previous subpic stream"; break; 
		case IDC_NSTREAM : pTTT->lpszText = "Go to next subpic stream"; break; 
		case IDC_APPLYTOALL : pTTT->lpszText = "Apply these modifications to all selected subpics"; break; 
		case IDC_REVERTALL : pTTT->lpszText = "Reloads all selected subpics from disk"; break; 
		case IDC_SPUSLIDER : pTTT->lpszText = "Picks a subpic in the current selection"; break; 
		case IDC_MOVEUDS : pTTT->lpszText = "Moves the subpic currently displayed up and down"; break; 
		case IDC_COLB : pTTT->lpszText = "Shows color used for 'b' (background) pixels"; break; 
		case IDC_COLP : pTTT->lpszText = "Shows color used for 'p'pixels"; break; 
		case IDC_COLE1 : pTTT->lpszText = "Shows color used for 'e1' (emphasis 1) pixels"; break; 
		case IDC_COLE2 : pTTT->lpszText = "Shows color used for 'e2' (emphasis 2) pixels"; break; 
		case IDC_NOCLUT : pTTT->lpszText = "Don't use the PGC Color LookUp Table (CLUT)."; break; 
		case IDC_SAVEALL : pTTT->lpszText = "Saves all the changes back to file."; break; 
		case IDC_MOVEUDE : pTTT->lpszText = "Enter amount to move the subpic here."; break; 
		case IDC_PIXSELECT : pTTT->lpszText = "Selects of which pixel to change the transparency. All means all non-background pixels."; break; 
		case IDC_TRANSPARENCYS : pTTT->lpszText = "Adjusts transparency for selected pixels."; break; 
		case IDC_START : pTTT->lpszText = "Select the subpic start command. Forced means the subpic will be on if the stream is selected, even if subtitles are off."; break; 
		case IDC_BORDERS : pTTT->lpszText = "Adjusts the vertical margin between subtitles and image borders. Only available if there are no buttons"; break; 
		case IDC_BORDERSELECT : pTTT->lpszText = "Pick standard values for vertical borders. Only available if there are no buttons"; break; 
		case IDC_SHOWMOD : pTTT->lpszText = "Only show modified subpics"; break; 
		}
		pTTT->hinst = AfxGetResourceHandle();
		return(TRUE);
    }
    return(FALSE);
}

// This function will be called after the display of each video frame.
void PostVideoDisplayFunc(HDC hDC,void* Param)
{
	CDVDSubEditDlg* DVDSubEdit = (CDVDSubEditDlg*) Param;
	// We simply call our DisplayBitmap function;
	DVDSubEdit->DisplayBitmap();
}

/////////////////////////////////////////////////////////////////////////////
// CDVDSubEditDlg message handlers

BOOL CDVDSubEditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    m_Menu.LoadMenu (IDR_MENU);
	SetMenu(&m_Menu);

	
	// TODO: Add extra initialization here
	DragAcceptFiles();
	EnableToolTips(true);

	TheSettings.LoadSettings(m_hWnd,"MainWindowPos",1);
	InitializeCriticalSection(&m_csLock);
	
	m_QuitNow = 0;
	m_Running = 0;
	m_ThreadHandle = 0;
	m_MoveBy = 0;
	strcpy(Message,"");
	m_ScanDialog = new CScanDlg;
	m_ScanDialog->CDialog::Create(IDD_SCANDIALOG);
	m_ScanDialog->m_Engine = this;
	TheSettings.LoadSettings(m_ScanDialog->m_hWnd,"ScanWindowPos",1);

	m_ApplyAllDialog = new CApplyToAllDlg;
	m_ApplyAllDialog->m_Engine = this;
	TheSettings.LoadSettings(m_ApplyAllDialog->m_hWnd,"ApplyAllWindowPos",1);

	TheSettings.LoadSettings(&m_DisplayVideo,"ShowVideo",1);
	m_ShowVideo.SetCheck(m_DisplayVideo);

	CRect Rect;
	GetDlgItem(IDC_SPUSLIDER)->GetWindowRect(&Rect);
	ScreenToClient(&Rect);
	m_DisplayHeight = Rect.top-20;

	JustFoundVideoFormat();
	Reset();

	ZeroMemory(&m_BitMapHeader, sizeof(BITMAPINFOHEADER));
	m_BitMapHeader.biSize = sizeof(BITMAPINFOHEADER);
	m_BitMapHeader.biPlanes = 1;
	m_BitMapHeader.biBitCount = 32;
	m_BitMapHeader.biCompression = BI_RGB;


	m_Preview = new CDVDPreview;
	m_Preview->SetDrawButtons(true);
	m_PreviewHandle = m_Preview->InitPreview(m_hWnd,1,1,100,100,SW_HIDE,true,WS_CHILD,true);

	// Now setup the preview so our PostVideoDisplayFunc function is called after each drawn video
	// frame...
	m_Preview->SetPostDisplayFunc(PostVideoDisplayFunc,this);
	EnableUI(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#define RESCALEX(x) ((int)((x)*m_ScalingX))
#define RESCALEY(x) ((int)((x)*m_ScalingY))

void CDVDSubEditDlg::JustFoundVideoFormat()
{
	GetClientRect(&m_VideoRect);
	int VideoHeight = (VideoFormat == FORMAT_PAL) ? 576 : 480;
	m_ScalingX = m_ScalingY = (float)m_DisplayHeight / VideoHeight;
	switch(m_AspectRatio)
	{
	case 1: m_ScalingX *= 1; break;
	case 2: m_ScalingX *= 4.f/3/720*VideoHeight; break;
	case 3: m_ScalingX *= 16.f/9/720*VideoHeight; break;
	case 4: m_ScalingX *= 2.21f/720*VideoHeight; break;
	}
	int temp = m_VideoRect.Width() - RESCALEX(720);
	m_VideoRect.left += temp/2;
	m_VideoRect.right -= temp/2;
	m_VideoRect.top += 10;
	m_VideoRect.bottom = m_VideoRect.top+m_DisplayHeight;

	m_Preview->SetVideoScaling(m_ScalingX,m_ScalingY);
	m_Preview->SetVideoPosition(m_VideoRect.left,m_VideoRect.top);
//	::ShowWindow(m_PreviewHandle,SW_SHOW);
	
}

void CDVDSubEditDlg::ShowCol(HDC TheDC, uint ID, uchar* Colormap)
{
//	HDC hDC = GetDC()->m_hDC;
	CRect Temp;
	GetDlgItem(ID)->GetWindowRect(&Temp);
	ScreenToClient(&Temp);
	FillRect(TheDC,Temp,(HBRUSH)CreateSolidBrush(RGB(Colormap[0],Colormap[1],Colormap[2])));
}




void CDVDSubEditDlg::DisplayBitmap(bool Black)
{
	CDC *TheDC = GetDC();
	DWORD LastError = GetLastError();
	if(!TheDC)
		return;
	HDC hDC = TheDC->m_hDC;

	// I'm keeping a local copy here to avoid m_SelectedSubPic becoming 0 under me, which sometimes happens,
	// when the video display is on, and I've no idea why >:(
	CSubPic* SelectedSubPic = m_SelectedSubPic;
	if(Black || SelectedSubPic == 0)
	{
		FillRect(hDC, &m_VideoRect, (HBRUSH)CreateSolidBrush(GREY));
		ReleaseDC(TheDC);
		return;
	}
	uchar* CLUT = 0;
	// Find which VCID this guy belongs to:
	int i;
	for(i=0;i<m_CLUTLength;i++)
	{
		if(m_VCIDList[i] == (uint)SelectedSubPic->m_VOBID*256+SelectedSubPic->m_CELLID)
		{
			if(m_CLUTs[i].m_NumCLUT > 0)
				CLUT = m_CLUTs[i].m_CLUT[0];
			// This also renames the streams according to the languages found. I should really only do
			// that when necessary...
			m_StreamSelect.ResetContent();
			m_StreamSelect.AddString("All Streams");
			int j;
			for(j=0;j<=m_TopStreamID;j++)
			{
				char Temp[16];
				sprintf(Temp,"0x%x (%c%c)",j+32,m_CLUTs[i].m_Languages[2*j],m_CLUTs[i].m_Languages[2*j+1]);
				m_StreamSelect.AddString(Temp);
			}
			m_StreamSelect.SetCurSel(m_SelectedStream);
			break;
		}
	}

	m_IgnoreCLUT.EnableWindow(CLUT != 0);
	m_IgnoreCLUT.SetWindowText(CLUT?"Ignore CLUT":"No CLUT");
	if(m_IgnoreCLUT.GetCheck()) CLUT = 0;

	// If this function is called by the preview after a video frame is displayed, we
	// won't erase the background!
	if(!m_DisplayVideo)
		FillRect(hDC, &m_VideoRect, (HBRUSH)CreateSolidBrush(GREY));

	// Create bitmap...
	m_BitMapHeader.biWidth = SelectedSubPic->m_ModSubPicWidth;
	m_BitMapHeader.biHeight = SelectedSubPic->m_SubPicHeight;
	m_BitMapHeader.biSizeImage = m_BitMapHeader.biWidth * m_BitMapHeader.biHeight * m_BitMapHeader.biBitCount / 8;
	m_HiddenDC = CreateCompatibleDC(TheDC->m_hDC);
	// This sometimes happens... I really don't know why...
	if(!m_HiddenDC)
		return;
	HBITMAP BitMapHandle = CreateDIBSection(m_HiddenDC, (LPBITMAPINFO)&m_BitMapHeader, 
		DIB_RGB_COLORS, (void**)&m_SubpicBitmap, NULL, 0x0);
	// Select bitmap. This also sometimes happens...
	if(!BitMapHandle)
		return;
	SelectObject(m_HiddenDC, BitMapHandle);
	// Write subpic into bitmap with transparency
	uchar* ColorMap = SelectedSubPic->SaveToAlphaBitmap((uchar*)m_SubpicBitmap,CLUT);

	// Show current CLUT colors...
	ShowCol(hDC, IDC_COLB,ColorMap); ShowCol(hDC,IDC_COLP,ColorMap+3);
	ShowCol(hDC, IDC_COLE1,ColorMap+6); ShowCol(hDC,IDC_COLE2,ColorMap+9);

	int ScaledWidth = RESCALEX(m_BitMapHeader.biWidth) ;
	int ScaledHeight = RESCALEY(m_BitMapHeader.biHeight);
	int ScaledStartX = m_VideoRect.left+RESCALEX(SelectedSubPic->m_StartX);
	int ScaledStartY = m_VideoRect.top+RESCALEY(SelectedSubPic->m_StartY);

	// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/gdi/bitmaps_6ig4.asp
	// http://www.codeproject.com/gdi/alphablend.asp
	ScaledHeight = min(ScaledHeight,m_VideoRect.bottom - m_VideoRect.top);
	BLENDFUNCTION BFunc = {AC_SRC_OVER,0,255,AC_SRC_ALPHA};
	AlphaBlend(
	hDC,                // handle to device context
	ScaledStartX,              // x-coordinate of upper-left corner of dest. rectangle
	ScaledStartY,              // y-coordinate of upper-left corner of dest. rectangle
	ScaledWidth,         // width of destination rectangle
	ScaledHeight,        // height of destination rectangle
	m_HiddenDC,
	0,               // x-coordinate of upper-left corner of source rectangle
	0,               // y-coordinate of upper-left corner of source rectangle
	m_BitMapHeader.biWidth ,          // width of source rectangle
	m_BitMapHeader.biHeight,         // height of source rectangle
	BFunc
	);

	// Now draw the borders if needed.
	if(SelectedSubPic->m_VerticalBorders != 0)
	{
		HPEN hpen;
		hpen = CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
		SelectObject(hDC, hpen);
		SelectObject(hDC, GetStockObject(HOLLOW_BRUSH)); 
		POINT Points[2];
		int VBorder = RESCALEY(SelectedSubPic->m_VerticalBorders);
		Points[0].x = m_VideoRect.left; Points[1].x = m_VideoRect.right; 
		Points[0].y = m_VideoRect.top+VBorder; 
		Points[1].y = m_VideoRect.top+VBorder;
		Polyline(hDC,Points,2);
		Points[0].y = m_VideoRect.bottom-VBorder-1; 
		Points[1].y = m_VideoRect.bottom-VBorder-1;
		Polyline(hDC,Points,2);
	}

    DeleteObject(BitMapHandle);
	ReleaseDC(TheDC);
	DeleteDC(m_HiddenDC);
}

void CDVDSubEditDlg::Reset()
{
	CSubPicEngine::Reset();
	SetWindowText(m_Version);
	m_SelectedStream = 0;
	m_PercentDone = 0;
	m_CommandDisplay.SetWindowText("");
	m_StreamSelect.ResetContent();
	m_StreamSelect.AddString("All Streams");
	m_StreamSelect.SetCurSel(0);
	m_VCIDSelect.ResetContent();
	m_VCIDSelect.AddString("All VCID");
	m_VCIDSelect.SetCurSel(0);
	m_SPUSlider.SetRange(0,0);
	m_ScalingY = m_ScalingX = 0;
	m_SPUSlider.ShowWindow(SW_HIDE);
	m_MoveVSlider.SetRange(0,MAX_V_MOVE*2);
	m_TransSlider.SetRange(0,15);
	m_BorderSlider.SetRange(0,MAX_BORDER);
	SetBorderSelect(-1);
	SetMoveSlider(MAX_V_MOVE);
	m_PixelSelect.SetCurSel(4);
	m_ApplyAllDialog->ResetAllCheck();
	DisplayBitmap(true);
	GetDlgItem(IDC_REVERTALL)->EnableWindow(false);
	GetDlgItem(IDC_REVERTSAVED)->EnableWindow(false);

	ZeroMemory(&m_CopyModif,sizeof(m_CopyModif));
}

void CDVDSubEditDlg::DispInfo(char* Info, COLORREF Color)
{
	int N = m_CommandDisplay.GetWindowTextLength();
	m_CommandDisplay.SetSel(-1,-1);
	m_CommandDisplay.ReplaceSel(Info);
	CHARFORMAT cf;
	cf.dwMask= CFM_COLOR | CFM_UNDERLINE;
	cf.dwEffects= 0;
	cf.crTextColor=Color;
	m_CommandDisplay.SetSel(N,m_CommandDisplay.GetWindowTextLength());
	m_CommandDisplay.SetSelectionCharFormat(cf);
}

void CDVDSubEditDlg::ViewSPU(int SPUIndex)
{
//	if(SPUIndex < m_PruneLength && m_SelectedSubPic!= 0)

	CopyModifs();
	if(SPUIndex < m_PruneLength)
	{
		m_SelectedSubPic = m_PrunedList[SPUIndex];
		// I'm keeping a local copy here to avoid m_SelectedSubPic becoming 0 under me, which sometimes happens,
		// when the video display is on, and I've no idea why >:(
		CSubPic* SelectedSubPic = m_SelectedSubPic;
		ASSERT(SelectedSubPic != 0);
		// Now show commands!
		m_CommandDisplay.SetWindowText("");
		char Temp[512];
		// Display various info.
		sprintf(Temp,"SPU# = %d\n",SelectedSubPic->m_SPUNumber); DispInfo(Temp,BLUE);
		sprintf(Temp,"StreamID = 0x%x\n",SelectedSubPic->m_StreamID+0x20); DispInfo(Temp,BLUE);
		sprintf(Temp,"LBA = %d\n",SelectedSubPic->m_LBAFrom[0]); DispInfo(Temp,BLUE);
		sprintf(Temp,"V/CID = %d/%d\n",SelectedSubPic->m_VOBID,SelectedSubPic->m_CELLID); DispInfo(Temp,BLUE);
		if(SelectedSubPic->m_DCSQT.size() == 1)
		{sprintf(Temp,"Duration = infinite\n"); DispInfo(Temp,BLUE);}
		else
		{sprintf(Temp,"Duration = %.3fs\n",(float)SelectedSubPic->m_DCSQT.back().m_Delay*1024/90000); DispInfo(Temp,BLUE);}
		if(SelectedSubPic->m_Modified)
			DispInfo("Modified\n",GREEN);
		while(RetreiveNextCommand(Temp) == 0)
			DispInfo(Temp,(Temp[0] != ' ')?RED:BLACK);
		SelectedSubPic->DecodeSubpic();
		SetMoveSlider(SelectedSubPic->m_LastVerticalMove+MAX_V_MOVE);
		int SelectedPixel = m_PixelSelect.GetCurSel();
		// The alphas are between 0 and 255;
		if(SelectedPixel < 4)
			SetTransSlider(SelectedSubPic->m_Alphas[SelectedPixel]/16);
		else
			SetTransSlider(SelectedSubPic->GetMeanTransparency());
		// Start command.
		m_StartCommand.SetCurSel(SelectedSubPic->FindCommand(STA_DSP) != -1 ? 0 : 1);

		// Borders.
		m_BorderSlider.EnableWindow(!SelectedSubPic->m_HasButtons);
		m_BorderSelect.EnableWindow(!SelectedSubPic->m_HasButtons);
		SetBorderSlider(SelectedSubPic->m_VerticalBorders);
		if(SelectedSubPic->m_VerticalBorders == (FORMAT_NTSC ? 65 : 78))
			SetBorderSelect(BORDER_4_3_LS);
		else if(SelectedSubPic->m_VerticalBorders == (FORMAT_NTSC ? 60 : 72))
			SetBorderSelect(BORDER_4_3_L);
		else if(SelectedSubPic->m_VerticalBorders == (FORMAT_NTSC ? 38 : 46))
			SetBorderSelect(BORDER_SAFE);
		else if(SelectedSubPic->m_VerticalBorders)
			SetBorderSelect(BORDER_CUSTOM);
		else 
			SetBorderSelect(-1);

		// Now's the time to display the video, if needed, then the subpics.
		if(!m_DisplayVideo)
			// No background video display. SImply display the bitmap.
			DisplayBitmap();
		else
		{
			// When showing the video, the preview is responsible for drawing
			// everything. DisplayBitmap() will be called after the frame is drawn.
			TRACE("Showing video %d\n",SelectedSubPic->m_NavPackLBA);
			m_Preview->GoToSector(SelectedSubPic->m_NavPackLBA);
			m_Preview->WaitForThread();
			::ShowWindow(m_PreviewHandle,SW_SHOW);
		}
		m_Revert.EnableWindow(SelectedSubPic->m_Modified && !m_Running);
	}
	else
	{
		m_SelectedSubPic = 0;
		// Just to erase the background...
		DisplayBitmap();
	}
}

void CDVDSubEditDlg::OnDestroy() 
{
	KillTimer(m_Timer);
	m_AbortNow = m_QuitNow = true;
	WaitForSingleObject(m_ThreadHandle,1000);
	m_ScanDialog->DestroyWindow();
	delete m_ScanDialog;
	m_ApplyAllDialog->DestroyWindow();
	delete m_ApplyAllDialog;
	m_Preview->CloseFile();
	delete m_Preview;
	m_Menu.DestroyMenu();
	CDialog::OnDestroy();
}

void BeforeFunc(LPVOID pParam)
{
	CDVDSubEditDlg* Dialog = (CDVDSubEditDlg*) pParam;
	Dialog->m_Timer = Dialog->SetTimer(0,200,NULL);
	Dialog->DragAcceptFiles(FALSE);
	Dialog->m_Running = 1;
	Dialog->m_ScanDialog->ShowWindow(SW_SHOW);
	Dialog->m_AbortNow = 0;
	Dialog->EnableUI(false);
}

void AfterFunc(LPVOID pParam)
{
	CDVDSubEditDlg* Dialog = (CDVDSubEditDlg*) pParam;
	if(!Dialog->m_QuitNow)
	{
		Dialog->KillTimer(Dialog->m_Timer);
		Dialog->DragAcceptFiles(TRUE);
		Dialog->EnableUI(true);
		Dialog->m_ScanDialog->ShowWindow(SW_HIDE);
		Dialog->m_ScanDialog->DisplayInfo(0,"","");
		Dialog->m_Phase = Processing_Idle;
		Dialog->SetMoveSlider(MAX_V_MOVE);
		Dialog->ViewSPU(Dialog->m_SPUSlider.GetPos());
	}
	Dialog->m_Running = 0;
	Dialog->m_ThreadHandle = 0;
}

UINT DVDSubEditScanFunction( LPVOID pParam )
{
	CDVDSubEditDlg* Dialog = (CDVDSubEditDlg*) pParam;
	BeforeFunc(pParam);

	Dialog->ScanFilesForSPUs();

	AfterFunc(pParam);

	if(!Dialog->m_QuitNow)
	{
		char Temp[512];
		sprintf(Temp,"%s ... -- %d SPUs found",Dialog->m_FileName[0],Dialog->m_TotNumSPU);
		Dialog->SetWindowText(Temp);
		Dialog->OnSelchangeStreamselect();
		Dialog->SetForegroundWindow();
		Sleep(1500);
	}
	return 0;
}

void CDVDSubEditDlg::StartScan() 
{
	if(m_Running == 0)
	{
		m_AbortNow = 0;
		EnableUI(false);
		CWinThread *Temp = AfxBeginThread( DVDSubEditScanFunction, this);
		m_ThreadHandle = Temp->m_hThread;
		m_Running = 1;
	}
	else
		m_AbortNow = 1;
}

void CDVDSubEditDlg::EnableUI(bool Enable)
{
	GetDlgItem(IDC_APPLYTOALL)->EnableWindow(Enable);
	GetDlgItem(IDC_REVERTALL)->EnableWindow(Enable);
	GetDlgItem(IDC_REVERTSAVED)->EnableWindow(Enable);
	GetDlgItem(IDC_SAVEALL)->EnableWindow(Enable);
}


void CDVDSubEditDlg::OnTimer(UINT nIDEvent) 
{
	static int Count = 0;

	if(m_QuitNow == 1)
		return;

	// Update progress bar...
	char Temp[512];
	switch(m_Phase)
	{
	case Processing_Idle : sprintf(Temp,"");break;
	case Processing_Scanning_VOB : 		
		sprintf(Temp,"Scanning VOB file(s)");
		break;
	case Processing_Done : sprintf(Temp,"Done...");break;
	case Processing_Aborted : sprintf(Temp,"Aborted");break;
	}

	if(m_Phase == Processing_Scanning_VOB)
		m_ScanDialog->DisplayInfo((int)m_PercentScanned,Temp,Message);
	if(m_Phase == Processing_Applying || m_Phase == Processing_Reverting)
		m_ScanDialog->DisplayInfo(m_PercentDone,"",Message);

	if(m_Running && Count++ % 5 == 0)
	{
		Count = 1;
		if(m_TotNumSPU < 2)
			OnSelchangeStreamselect();
		else
			UpdateSPUList();
	}

	CDialog::OnTimer(nIDEvent);
}

//////////////////////////////////////////////////////////////////////////////////////////////
void CDVDSubEditDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.m_Edit = this;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDVDSubEditDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		TRACE("ONPAINT\n");
		CDialog::OnPaint();
		PAINTSTRUCT Ps;
		BeginPaint(&Ps);
		DisplayBitmap();
		EndPaint(&Ps);
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDVDSubEditDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


#define MAX_NUM_FILES 64
void CDVDSubEditDlg::OnDropFiles(HDROP hDropInfo) 
{
	if(WarnIfModifs() == false)
		return;
	SetForegroundWindow();      // activate us first !
	POINT ThePoint;
	DragQueryPoint(hDropInfo,&ThePoint);

	UINT nFiles = ::DragQueryFile(hDropInfo, (UINT)-1, NULL, 0);
	CWinApp* pApp = AfxGetApp();
	ASSERT(pApp != NULL);
	char FileNames[MAX_NUM_FILES][512];
	int i;
	for(i=0;i<MAX_NUM_FILES;i++)
		strcpy(FileNames[i],"");
	int VTSNum = 0;
	for (UINT iFile = 0; iFile < nFiles; iFile++)
	{
		TCHAR szFileName[_MAX_PATH];
		::DragQueryFile(hDropInfo, iFile, szFileName, _MAX_PATH);
		if(strcmpi(GetExt(szFileName),".vob") != 0)
		{
			AfxMessageBox("Error: I can only open VOB files");
			::DragFinish(hDropInfo);
			return;
		}
		int Index = -1;
		int VTS = -1;
		// Get VTS number and index.
		if(sscanf(GetFname(szFileName),"%*[^_]_%d_%d",&VTS,&Index) != 2)
		{
			// Probably not a "vts_xx_xx", let's just add to our list at the next index...
			Index = (int)iFile;
			VTSNum = 0;
		}
		if(VTSNum == 0) VTSNum = VTS;
		else if(VTSNum != VTS)
		{
			AfxMessageBox("All the VOB files must come from the same VTS");
			::DragFinish(hDropInfo);
			return;
		}
		ASSERT(Index < 10 && Index >= 0);
		strcpy(FileNames[Index],szFileName);
	}
	::DragFinish(hDropInfo);
	
	// Now put these file names in order...
	Reset();
	for(i=0;i<MAX_NUM_FILES;i++)
	{
		if(strcmp(FileNames[i],"") == 0)
			continue;
		if(AddFile(FileNames[i]) == -1)
		{
			char Temp[512];
			sprintf(Temp,"Error opening %s\nIs the file writeable?",FileNames[i]);
			AfxMessageBox(Temp);
			return;
		}
		else
		{
			SetWindowText(FileNames[i]);
		}
	}
	EnableUI(true);

	// Now scan input files...
	m_ScanDialog->DisplayInfo(0,"","");
	m_ScanDialog->ShowWindow(SW_SHOW);
	StartScan();
	m_Preview->LoadFile(m_FileName[0]);
}


HBRUSH CDVDSubEditDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	int id = pWnd->GetDlgCtrlID();
	//COLORREF bkcolor = pDC->GetBkColor();
	if (id == IDC_INFO || id == IDC_MESSAGE)
	{
		// Set the text color to black
		pDC->SetTextColor(RGB(0, 0, 0)); 
	}	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CDVDSubEditDlg::OnSpur() 
{
	m_SPUSlider.SetPos(m_SPUSlider.GetPos()+1);
	ViewSPU(m_SPUSlider.GetPos()); 
	m_ApplyAllDialog->ResetAllCheck();
}

void CDVDSubEditDlg::OnSpul() 
{
	m_SPUSlider.SetPos(m_SPUSlider.GetPos()-1);
	ViewSPU(m_SPUSlider.GetPos()); 
	m_ApplyAllDialog->ResetAllCheck();
}

void CDVDSubEditDlg::JustAddedSPU(int StreamIndex, int SPUIndex)
{
	if(m_QuitNow)
		return;
	if(m_TotNumSPU == 1)
		OnSelchangeStreamselect();
}

void CDVDSubEditDlg::JustFoundStream(int StreamIndex)
{
	if(m_QuitNow)
		return;
	if(StreamIndex+1 < m_StreamSelect.GetCount())
		return;
	m_StreamSelect.ResetContent();
	m_StreamSelect.AddString("All Streams");
	int i;
	for(i=0;i<=m_TopStreamID;i++)
	{
		char Temp[16];
		sprintf(Temp,"0x%x",i+32);
		m_StreamSelect.AddString(Temp);
	}
	m_StreamSelect.SetCurSel(m_SelectedStream);
}

void CDVDSubEditDlg::JustFoundVCID(uint VCID)
{
	if(m_QuitNow)
		return;
	char Temp[64];
	sprintf(Temp,"%d/%d",VCID/256,VCID%256);
	m_VCIDSelect.AddString(Temp);
	ScanIFOs();
}

void CDVDSubEditDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	switch(pScrollBar->GetDlgCtrlID())
	{
	case IDC_SPUSLIDER : {
		static int LastPos = 0;
		if(LastPos == m_SPUSlider.GetPos())
			break;
		LastPos = m_SPUSlider.GetPos();
		ViewSPU(LastPos); 
		m_ApplyAllDialog->ResetAllCheck();
		break;}
	case IDC_MOVEUDS : 
		DispThis2(IDC_MOVEUDE,"%d",m_MoveVSlider.GetPos()-MAX_V_MOVE);
		if(m_SelectedSubPic)// && nSBCode == SB_ENDSCROLL) 
		{
			m_SelectedSubPic->MoveSubPic(m_MoveVSlider.GetPos()-MAX_V_MOVE);
			// Be smart: if we move the move slider, we probably want to apply that!
			m_ApplyAllDialog->m_ApplyMove = true;
			ViewSPU(m_SPUSlider.GetPos());
		}
		break;
	case IDC_TRANSPARENCYS : 
		if(m_SelectedSubPic)// && nSBCode == SB_ENDSCROLL) 
		{
			int SelectedPixel = m_PixelSelect.GetCurSel();
			int CurTrans = m_TransSlider.GetPos();
			// Be smart: if we move the transparency slider, we probably want to apply that!
			m_ApplyAllDialog->m_ApplyTransp = true;
			m_SelectedSubPic->ChangeTransparency(CurTrans,SelectedPixel);
			ViewSPU(m_SPUSlider.GetPos());
		}
		break;
	case IDC_BORDERS : 
		if(m_SelectedSubPic)
		{
			int TopBorder = m_BorderSlider.GetPos();
			DispThis2(IDC_BORDERE,"%d",TopBorder);
			m_SelectedSubPic->MoveSubPicInFrame(TopBorder);
			ViewSPU(m_SPUSlider.GetPos());
			if(TopBorder == 0)
				SetBorderSelect(-1);
			else 
				SetBorderSelect(BORDER_CUSTOM);
			m_ApplyAllDialog->m_ApplyBorders = TopBorder != 0;

		}
		break;
	default: break;
	}
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDVDSubEditDlg::SetMoveSlider(int Pos)
{
	m_MoveVSlider.SetPos(Pos);
	DispThis2(IDC_MOVEUDE,"%d",Pos-MAX_V_MOVE);
}

void CDVDSubEditDlg::SetTransSlider(int Pos)
{
	m_TransSlider.SetPos(Pos);
	DispThis2(IDC_TRANSPARENCYE,"%d",Pos);
}

void CDVDSubEditDlg::SetBorderSlider(int Pos)
{
	m_BorderSlider.SetPos(Pos);
	DispThis2(IDC_BORDERE,"%d",Pos);
}

void CDVDSubEditDlg::SetBorderSelect(int Selection)
{
	if(Selection == 0)
	{
		// Custom borders.
		m_BorderSelect.DeleteString(0);
		m_BorderSelect.InsertString(0,"Custom Vertical Borders");
		m_BorderSelect.SetCurSel(Selection);
	}
	else if(Selection > 0)
	{
		// Standard borders.
		m_BorderSelect.DeleteString(0);
		m_BorderSelect.InsertString(0,"No Vertical Borders");
		m_BorderSelect.SetCurSel(Selection);
	}
	else
	{
		// -1 means, no border. Change the string name!
		m_BorderSelect.DeleteString(0);
		m_BorderSelect.InsertString(0,"No Vertical Borders");
		m_BorderSelect.SetCurSel(0);
	}
}

void CDVDSubEditDlg::OnSelchangeStreamselect() 
{
	UpdateSPUList();
	if(m_PruneLength)
	{
		ViewSPU(m_SPUSlider.GetPos());
	}
	else
		m_CommandDisplay.SetWindowText("");
}

void CDVDSubEditDlg::OnShowmod() 
{
	UpdateSPUList();
}

void CDVDSubEditDlg::UpdateSPUList()
{
	// User changed the selected stream. Create the pruned list.
	int ThisPos = m_SPUSlider.GetPos();
	int NextPos = 0;
	m_SelectedStream = m_StreamSelect.GetCurSel();
	int CurrentVCID = m_VCIDSelect.GetCurSel();
	if(CurrentVCID == 0)
		NextPos = PruneSPUList(ThisPos,m_SelectedStream-1,-1,-1,0,0,m_ShowModified.GetCheck());
	else
		NextPos = PruneSPUList(ThisPos,m_SelectedStream-1,-1,-1,m_VCIDList[CurrentVCID-1]/256,
			m_VCIDList[CurrentVCID-1]%256,m_ShowModified.GetCheck());

	m_SPUSlider.SetRange(0,m_PruneLength-1,true);
	m_SPUSlider.ShowWindow((m_PruneLength > 1)?SW_SHOW:SW_HIDE);
	if(NextPos != -1)
		m_SPUSlider.SetPos(NextPos);
	GetDlgItem(IDC_SPUL)->ShowWindow((m_PruneLength > 1)?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_SPUR)->ShowWindow((m_PruneLength > 1)?SW_SHOW:SW_HIDE);
	char Temp[64];
	sprintf(Temp,"%d SPUs",m_PruneLength);
	SetDlgItemText(IDC_NUMPRUNED,Temp);
	ViewSPU(m_SPUSlider.GetPos());
}

BOOL CDVDSubEditDlg::PreTranslateMessage(MSG* pMsg) 
{
	unsigned short Mask = 0x8000;

	// This will capture all messages arriving at the app before they're translated and dispatched.
	// We'll just intercept Num Pad message and use them to select which sound to playback...
	if(pMsg->message == WM_KEYDOWN)
	{
		BOOL ShiftOn = (GetAsyncKeyState(VK_SHIFT) & Mask);
		BOOL CtrlOn = (GetAsyncKeyState(VK_CONTROL) & Mask);
		switch(pMsg->wParam)
		{
			// Must be all CAPS...
		case VK_F5:	OnSelchangeStreamselect(); ScanIFOs(); break;
		case VK_RIGHT:	OnSpur(); break;
		case VK_LEFT:	OnSpul(); break;
		case VK_ESCAPE: m_AbortNow = true;  break;
		case 'V': if(CtrlOn) OnEditRedo(); break;
		case 'A': if(CtrlOn) OnEditApplyall(); break;
		case 'Z': if(CtrlOn) OnRevertsaved(); break;
		case 'E' : m_Preview->EraseVideoFrame(); break;
		case 'T' : 
// Anamorphic info: size of bars when 16:9 is letterboxed to 4:3... In NTSC:
// H=480 = 3x/4 (x is horiz size in rect. pixels) -> x = 640.
// 16:9 H = 9x/16 = 360. (480-360)/2 = 60
// PAL: 576 = 3x/4 -> x = 768
// 16:9 H = 9x/16 = 432. (576-432)/2 = 72
			{
			int barT = VideoFormat == FORMAT_NTSC ? 60 : 72;
			if(m_SelectedSubPic->MoveSubPicInFrame(barT))
				ViewSPU(m_SPUSlider.GetPos());break;}
		default: return CDialog::PreTranslateMessage(pMsg);
		}
		return TRUE;
	}
	else return CDialog::PreTranslateMessage(pMsg);
}

void CDVDSubEditDlg::OnRevertsaved() 
{
	if(m_SelectedSubPic != 0)
		m_SelectedSubPic->ReloadSPU();
	SetMoveSlider(MAX_V_MOVE);
	UpdateSPUList();
	m_ApplyAllDialog->ResetAllCheck();
}


void CDVDSubEditDlg::OnPvcid() 
{
	if(m_VCIDSelect.GetCurSel() < 1) return;
	m_VCIDSelect.SetCurSel(m_VCIDSelect.GetCurSel()-1);
	OnSelchangeStreamselect();
}

void CDVDSubEditDlg::OnNvcid() 
{
	if(m_VCIDSelect.GetCurSel() >= m_VCIDLength) return;
	m_VCIDSelect.SetCurSel(m_VCIDSelect.GetCurSel()+1);
	OnSelchangeStreamselect();
}

void CDVDSubEditDlg::OnPstream() 
{
	if(m_StreamSelect.GetCurSel() < 1) return;
	m_StreamSelect.SetCurSel(m_StreamSelect.GetCurSel()-1);
	OnSelchangeStreamselect();
}

void CDVDSubEditDlg::OnNstream() 
{
	if(m_StreamSelect.GetCurSel() >= m_TopStreamID+1) return;
	m_StreamSelect.SetCurSel(m_StreamSelect.GetCurSel()+1);
	OnSelchangeStreamselect();
}


UINT ApplyToAllFunc(LPVOID pParam)
{
	CDVDSubEditDlg* Dialog = (CDVDSubEditDlg*) pParam;
	BeforeFunc(pParam);

	Dialog->m_Phase = Processing_Applying;
	Dialog->m_ScanDialog->SetWindowText("Applying modifications");
#if 0
	int Border = Dialog->m_BorderSlider.GetPos();
	int Transparency = Dialog->m_TransSlider.GetPos();
	int PixSelect = Dialog->m_PixelSelect.GetCurSel();
	int StartSelect = Dialog->m_StartCommand.GetCurSel();
#else
	int Moveby = Dialog->m_CopyModif.m_VMove;
	int Border = Dialog->m_CopyModif.m_Border;
	int Transparency = Dialog->m_CopyModif.m_Transparency;
	int PixSelect = Dialog->m_CopyModif.m_TranspPixel;
	int StartSelect = Dialog->m_CopyModif.m_StartCommand;
#endif
	sprintf(Message,"Applying modifications");
	int i;
	for(i=0;i<Dialog->m_PruneLength;i++)
	{
		// Don't double apply!
//		if(Dialog->m_PrunedList[i] == Dialog->m_SelectedSubPic)
//			continue;
		// Check which of the modifications should be applied to all..
		if(Dialog->m_ApplyAllDialog->m_ApplyBorders)
			Dialog->m_PrunedList[i]->MoveSubPicInFrame(Border);
		if(Dialog->m_ApplyAllDialog->m_ApplyMove)
			Dialog->m_PrunedList[i]->MoveSubPic(Moveby);
		if(Dialog->m_ApplyAllDialog->m_ApplyTransp)
			Dialog->m_PrunedList[i]->ChangeTransparency(Transparency,PixSelect);
		if(Dialog->m_ApplyAllDialog->m_ApplyStart)
		{
			if(StartSelect == 0)
				Dialog->m_PrunedList[i]->ChangeCommand(FSTA_DSP,STA_DSP);
			else
				Dialog->m_PrunedList[i]->ChangeCommand(STA_DSP,FSTA_DSP);
		}
		Dialog->m_PercentDone = i*100/Dialog->m_PruneLength;
	}
	Dialog->m_ApplyAllDialog->ResetAllCheck();
	AfterFunc(pParam);
	return 0;
}

UINT RevertAllFunc(LPVOID pParam)
{
	CDVDSubEditDlg* Dialog = (CDVDSubEditDlg*) pParam;
	BeforeFunc(pParam);

	Dialog->m_Phase = Processing_Reverting;
	Dialog->m_ScanDialog->SetWindowText("Reverting changes");
	sprintf(Message,"Reverting changes");
	int i;
	for(i=0;i<Dialog->m_PruneLength;i++)
	{
		Dialog->m_PrunedList[i]->ReloadSPU();
		Dialog->m_PercentDone = i*100/Dialog->m_PruneLength;
	}
	Dialog->m_ApplyAllDialog->ResetAllCheck();
	Dialog->UpdateSPUList();
	AfterFunc(pParam);
	return 0;
}

UINT SaveAllFunc(LPVOID pParam)
{
	CDVDSubEditDlg* Dialog = (CDVDSubEditDlg*) pParam;
	BeforeFunc(pParam);

	Dialog->m_Phase = Processing_Saving;
	Dialog->m_ScanDialog->SetWindowText("Saving changes");
	sprintf(Message,"Saving changes");
	int i;
	for(i=0;i<Dialog->m_PruneLength;i++)
	{
		if(Dialog->m_PrunedList[i]->m_Modified)
			Dialog->m_PrunedList[i]->SaveSPU();
		Dialog->m_PercentDone = i*100/Dialog->m_PruneLength;
	}
	AfterFunc(pParam);
	return 0;
}

void CDVDSubEditDlg::OnApplytoall() 
{
	if(m_Running) return;
	m_MoveBy = m_MoveVSlider.GetPos()-MAX_V_MOVE;
	if(m_ApplyAllDialog->DoModal() != IDOK)
		return;
	CWinThread *Temp = AfxBeginThread( ApplyToAllFunc, this);
	m_ThreadHandle = Temp->m_hThread;
	m_Running = 1;
}

void CDVDSubEditDlg::OnSaveall() 
{
	if(m_Running) return;
	if(AfxMessageBox("This will save all your changes to file. No undo...\nProceed?",MB_OKCANCEL) != IDOK)
		return;
	CWinThread *Temp = AfxBeginThread( SaveAllFunc, this);
	m_ThreadHandle = Temp->m_hThread;
	m_Running = 1;
}


void CDVDSubEditDlg::OnRevertall() 
{
	if(m_Running) return;
	if(AfxMessageBox("This will undo all your changes... Proceed?",MB_OKCANCEL) != IDOK)
		return;
	CWinThread *Temp = AfxBeginThread( RevertAllFunc, this);
	m_ThreadHandle = Temp->m_hThread;
	m_Running = 1;
}

void CDVDSubEditDlg::OnShowvideo() 
{
	m_DisplayVideo = m_ShowVideo.GetCheck();
	ViewSPU(m_SPUSlider.GetPos());	
}

void CDVDSubEditDlg::OnClose() 
{
	if(WarnIfModifs() == false)
		return;
	// Saving preferences here because ScanDialog is a child and will be destroyed before OnDestroy.
	TheSettings.SaveSettings();
	CDialog::OnClose();
}

bool CDVDSubEditDlg::WarnIfModifs()
{
	int i;
	for(i=0;i<m_TotNumSPU;i++)
	{
		if(m_MasterList[i]->m_Modified)
			break;
	}
	if(i != m_TotNumSPU && 
		AfxMessageBox("You have modified some of the SPUs... Really close?",MB_OKCANCEL) != IDOK)
		return false;
	return true;
}

void CDVDSubEditDlg::OnNoclut() 
{
	ViewSPU(m_SPUSlider.GetPos());	
}


void CDVDSubEditDlg::OnDefbutton() 
{
	SetFocus();
}

void CDVDSubEditDlg::OnKillfocusMoveude() 
{
	int move = GetDlgItemInt(IDC_MOVEUDE);
	move = min(MAX_V_MOVE,move);
	move = max(-MAX_V_MOVE,move);
	SetMoveSlider(MAX_V_MOVE+move);
	if(!m_SelectedSubPic)
		return ;
	m_SelectedSubPic->MoveSubPic(m_MoveVSlider.GetPos()-MAX_V_MOVE); 
	ViewSPU(m_SPUSlider.GetPos());
}

void CDVDSubEditDlg::OnKillfocusBordere() 
{
	int border = GetDlgItemInt(IDC_BORDERE);
	border = min(border,MAX_BORDER);
	border = max(border,0);
	SetBorderSlider(border);
	if(!m_SelectedSubPic)
		return ;
	m_SelectedSubPic->MoveSubPicInFrame(border); 
	ViewSPU(m_SPUSlider.GetPos());
}

void CDVDSubEditDlg::OnSelchangePixselect() 
{
	ViewSPU(m_SPUSlider.GetPos());
}

void CDVDSubEditDlg::OnSelchangeStart() 
{
	if(!m_SelectedSubPic)
		return ;
	// Change the start command according to the selector...
	if(m_StartCommand.GetCurSel() == 0)
		m_SelectedSubPic->ChangeCommand(FSTA_DSP,STA_DSP);
	else
		m_SelectedSubPic->ChangeCommand(STA_DSP,FSTA_DSP);
	// Be smart, if se change the start command, we might want to apply to all.
	m_ApplyAllDialog->m_ApplyStart = true;
	ViewSPU(m_SPUSlider.GetPos());	
}

void CDVDSubEditDlg::OnSelchangeBorderselect() 
{
	if(!m_SelectedSubPic)
		return ;
	switch(m_BorderSelect.GetCurSel())
	{
	case BORDER_CUSTOM:
		m_SelectedSubPic->MoveSubPicInFrame(0);
		m_ApplyAllDialog->m_ApplyBorders = false;
		ViewSPU(m_SPUSlider.GetPos());
		break;
	case BORDER_SAFE: 
		// I'm using 8% for the safe area.
		m_SelectedSubPic->MoveSubPicInFrame((FORMAT_NTSC ? 38 : 46));
		m_ApplyAllDialog->m_ApplyBorders = true;
		ViewSPU(m_SPUSlider.GetPos());
		break;
	case BORDER_4_3_L: 
		// 16:9 Letterboxed.
		m_SelectedSubPic->MoveSubPicInFrame((FORMAT_NTSC ? 60 : 72));
		m_ApplyAllDialog->m_ApplyBorders = true;
		ViewSPU(m_SPUSlider.GetPos());
		break;
	case BORDER_4_3_LS: 
		// 16:9 letterboxed safe.
		m_SelectedSubPic->MoveSubPicInFrame((FORMAT_NTSC ? 65 : 78));
		m_ApplyAllDialog->m_ApplyBorders = true;
		ViewSPU(m_SPUSlider.GetPos());
		break;
	}
}

void CDVDSubEditDlg::OnDeltaposMoveb(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	SetMoveSlider(m_MoveVSlider.GetPos()-2*pNMUpDown->iDelta);
	if(m_SelectedSubPic)
	{
		m_SelectedSubPic->MoveSubPic(m_MoveVSlider.GetPos()-MAX_V_MOVE);
		ViewSPU(m_SPUSlider.GetPos());
	}
	*pResult = 0;
}


void CDVDSubEditDlg::OnDeltaposBorderb(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	SetBorderSlider(m_BorderSlider.GetPos()-pNMUpDown->iDelta);
	if(m_SelectedSubPic)
	{
		m_SelectedSubPic->MoveSubPicInFrame(m_BorderSlider.GetPos());
		ViewSPU(m_SPUSlider.GetPos());
	}
	*pResult = 0;
}


















// __________________________ MENU STUFF _______________________


void CDVDSubEditDlg::OnHelpAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.m_Edit = this;
	dlgAbout.DoModal();
}

void CDVDSubEditDlg::OnHelpManual() 
{
	OpenRSCFile(IDR_HELPFILE, ".pdf");
}

void CDVDSubEditDlg::OnHelpOntheweb() 
{
	ShellExecute(NULL, "open", "http://www.videohelp.com/~DVDSubEdit", NULL, NULL, SW_SHOWNORMAL);
}

void CDVDSubEditDlg::CopyModifs() 
{
	// Copy the modifications made to this spu.
	if(m_ApplyAllDialog->AnyChecked() == false)
		return;
	Modif Null = {-1,-1,-1,-1,-1};
	m_CopyModif = Null;
	if(m_ApplyAllDialog->m_ApplyMove)
		m_CopyModif.m_VMove = m_MoveVSlider.GetPos()-MAX_V_MOVE;

	if(m_ApplyAllDialog->m_ApplyBorders)
		m_CopyModif.m_Border = m_BorderSlider.GetPos();

	if(m_ApplyAllDialog->m_ApplyTransp)
	{
		m_CopyModif.m_Transparency = m_TransSlider.GetPos();
		m_CopyModif.m_TranspPixel = m_PixelSelect.GetCurSel();
	}

	if(m_ApplyAllDialog->m_ApplyStart)
		m_CopyModif.m_StartCommand = m_StartCommand.GetCurSel();
}

void CDVDSubEditDlg::OnEditRedo() 
{
	if(m_SelectedSubPic == 0)
		return;
	if(m_CopyModif.m_VMove != -1)
		m_SelectedSubPic->MoveSubPic(m_CopyModif.m_VMove);
	if(m_CopyModif.m_Border != -1)
		m_SelectedSubPic->MoveSubPicInFrame(m_CopyModif.m_Border);
	if(m_CopyModif.m_Transparency != -1)
		m_SelectedSubPic->ChangeTransparency(m_CopyModif.m_Transparency,m_CopyModif.m_TranspPixel);
	if(m_CopyModif.m_StartCommand != -1)
	{
		if(m_CopyModif.m_StartCommand == 0)
			m_SelectedSubPic->ChangeCommand(FSTA_DSP,STA_DSP);
		else
			m_SelectedSubPic->ChangeCommand(STA_DSP,FSTA_DSP);
	}
	ViewSPU(m_SPUSlider.GetPos());
}

void CDVDSubEditDlg::OnFileExit() 
{
    AfxGetMainWnd()->SendMessage(WM_CLOSE);
//	::PostQuitMessage(0);
}

void CDVDSubEditDlg::OnEditApplyall() 
{
	if(m_SelectedSubPic == 0)
		return;
	m_ApplyAllDialog->m_ApplyMove = m_CopyModif.m_VMove != -1;
	m_ApplyAllDialog->m_ApplyBorders = m_CopyModif.m_Border != -1;
	m_ApplyAllDialog->m_ApplyStart = m_CopyModif.m_StartCommand != -1;
	m_ApplyAllDialog->m_ApplyTransp = m_CopyModif.m_Transparency != -1;
	OnApplytoall();
}


void CDVDSubEditDlg::OnFileOpenvob() 
{
	if(WarnIfModifs() == false)
		return;
	static CFileDialog FileDialog(TRUE, CString("*.vob"), "", 0, CString("VOB Files (*.vob)|*.vob||"));
	if (FileDialog.DoModal() == IDOK)
	{
		Reset();
		AddFile((char*)(LPCTSTR)FileDialog.GetPathName());
		EnableUI(true);
		// Now scan input file...
		m_ScanDialog->DisplayInfo(0,"","");
		m_ScanDialog->ShowWindow(SW_SHOW);
		StartScan();
		m_Preview->LoadFile(m_FileName[0]);	
	}
}

void CDVDSubEditDlg::OnFileOpendomain() 
{
	if(WarnIfModifs() == false)
		return;
	static CFileDialog FileDialog(TRUE, CString("*.vob"), "", 0, CString("VOB Files (*.vob)|*.vob||"));
	if (FileDialog.DoModal() == IDOK)
	{
		Reset();
		int Index = -1;
		int VTS = -1;
		char FileName[1024];
		strcpy(FileName,(char*)(LPCTSTR)FileDialog.GetPathName());
		// Get VTS number and index.
		if(sscanf(GetFname(FileName),"%*[^_]_%d_%d",&VTS,&Index) == 2 && Index > 0)
		{
			// This is a vts_nn_x.vob
			for(int i=1;i<10;i++)
			{
				FileName[strlen(FileName)-5]='0'+i;
				if(PathExists(FileName))
					AddFile(FileName);
			}
		}
		else
			AddFile(FileName);
		EnableUI(true);
		// Now scan input file...
		m_ScanDialog->DisplayInfo(0,"","");
		m_ScanDialog->ShowWindow(SW_SHOW);
		StartScan();
		m_Preview->LoadFile(m_FileName[0]);	
	}
}
