// DVDSubEditDlg.h : header file
//

#if !defined(AFX_DVDSubEditDLG_H__8849CA41_8885_4178_8047_BB28B35DE116__INCLUDED_)
#define AFX_DVDSubEditDLG_H__8849CA41_8885_4178_8047_BB28B35DE116__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Utils.h"
#include "SubPicEngine.h"
#include "DVDPreview.h"

class CScanDlg;
class CApplyToAllDlg;

typedef struct
{
	int		m_VMove;
	int		m_Border;
	int		m_Transparency;
	int		m_TranspPixel;
	int		m_StartCommand;
} Modif;

/////////////////////////////////////////////////////////////////////////////
// CDVDSubEditDlg dialog

class CDVDSubEditDlg : public CDialog, public CSubPicEngine
{
// Construction
public:
	CDVDSubEditDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDVDSubEditDlg)
	enum { IDD = IDD_DVDSubEdit_DIALOG };
	CButton	m_ShowModified;
	CComboBox	m_BorderSelect;
	CSliderCtrl	m_BorderSlider;
	CComboBox	m_StartCommand;
	CComboBox	m_PixelSelect;
	CSliderCtrl	m_TransSlider;
	CButton	m_ShowVideo;
	CButton	m_SaveAll;
	CButton	m_IgnoreCLUT;
	CButton	m_Revert;
	CSliderCtrl	m_MoveVSlider;
	CComboBox	m_VCIDSelect;
	CSliderCtrl	m_SPUSlider;
	CComboBox	m_StreamSelect;
	CRichEditCtrl	m_CommandDisplay;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDVDSubEditDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL
	BOOL OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult );

public:
	CSettings			TheSettings;
	CScanDlg			*m_ScanDialog;
	CApplyToAllDlg		*m_ApplyAllDialog;
	CDVDPreview			*m_Preview;
	HWND				m_PreviewHandle;

	CMenu				m_Menu;
	
	Modif				m_CopyModif;

	int					m_DisplayVideo;

	void				OnDropFiles(HDROP hDropInfo) ;
	void				StartScan();
	virtual void		JustAddedSPU(int StreamIndex, int SPUIndex);
	virtual void		JustFoundStream(int StreamIndex);
	virtual void		JustFoundVCID(uint VCID);
	virtual void		Reset();
	virtual void		JustFoundVideoFormat();
//	virtual int			PruneSPUList(int CurrentSelected, int StreamID = -1, int StartLBA = -1, int EndLBA = -1,
//		ushort VOBID = 0, uchar CELLID = 0);
						
	void				EnableUI(bool Enable);
	int					m_SelectedStream;
	void				ShowCol(HDC TheDC, uint ID, uchar* Colormap);
	void				ViewSPU(int SPUIndex);

	int					m_Running;
	bool				m_QuitNow;
	int					m_Timer;
	HANDLE				m_ThreadHandle;
	int					m_DisplayHeight;
	int					m_MoveBy;
	int					m_PercentDone;

	HDC					m_HiddenDC;
	BITMAPINFOHEADER	m_BitMapHeader;
	unsigned char*		m_SubpicBitmap ;
	float				m_ScalingX;
	float				m_ScalingY;
	CRect				m_VideoRect;

	// This is used to avoid stepping on my own feet.
	CRITICAL_SECTION	m_csLock;

// Implementation
	HICON m_hIcon;

	void				DispInfo(char* Info, COLORREF Color);
	void				UpdateSPUList();
	void				DisplayBitmap(bool Black = false);
	void				SetMoveSlider(int Pos);
	void				SetTransSlider(int Pos);
	void				SetBorderSlider(int Pos);
	void				SetBorderSelect(int Selection);
	void				CopyModifs();
	bool				WarnIfModifs();

	// Generated message map functions
	//{{AFX_MSG(CDVDSubEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnSpur();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSelchangeStreamselect();
	afx_msg void OnSpul();
	afx_msg void OnRevertsaved();
	afx_msg void OnPvcid();
	afx_msg void OnNvcid();
	afx_msg void OnPstream();
	afx_msg void OnNstream();
	afx_msg void OnApplytoall();
	afx_msg void OnRevertall();
	afx_msg void OnClose();
	afx_msg void OnNoclut();
	afx_msg void OnSaveall();
	afx_msg void OnDefbutton();
	afx_msg void OnKillfocusMoveude();
	afx_msg void OnShowvideo();
	afx_msg void OnSelchangePixselect();
	afx_msg void OnSelchangeStart();
	afx_msg void OnSelchangeBorderselect();
	afx_msg void OnShowmod();
	afx_msg void OnKillfocusBordere();
	afx_msg void OnHelpAbout();
	afx_msg void OnHelpManual();
	afx_msg void OnHelpOntheweb();
	afx_msg void OnEditRedo();
	afx_msg void OnFileExit();
	afx_msg void OnEditApplyall();
	afx_msg void OnDeltaposMoveb(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposBorderb(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnFileOpenvob();
	afx_msg void OnFileOpendomain();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
protected:
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DVDSubEditDLG_H__8849CA41_8885_4178_8047_BB28B35DE116__INCLUDED_)
